/*
Copyright (C) 1999/2000 Hendrik Lipka.
All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along with this
program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA or see http://www.gnu.org

If you encounter problems or have a suggestion, please mail to:
q3master@hendriklipka.de
*/

package de.hendriklipka.q3master;

/**
 * Title:        Quake3Arena MasterBrowser
 * Description:
 * Copyright:    Copyright (c) 2001 by Hendrik Lipka
 * @author Hendrik Lipka
 * @version 0.1
*/

import org.log4j.*;

public class Q3Master
{
    private Category CAT=Category.getInstance(Q3Master.class.getName());
    private Category LOG_CAT=Category.getInstance("q3master.main");

    public Q3Master(String cfgFile)
    {
        // read configuration
        System.out.println("reading config from "+cfgFile);
        Configuration.getInstance().readConfigFile(cfgFile);

        // initialize log4j
        String l4jCfg=Configuration.getInstance().getLog4jConfigFile();
        System.out.println("configuring log4j with "+l4jCfg);
        PropertyConfigurator.configure(l4jCfg);

        LOG_CAT.info("starting");

        // start status handler
        StatusHandler st=new StatusHandler();
        LOG_CAT.info("created status handler");

        // start UDP listener
        int port=Configuration.getInstance().getListenPort();
        RequestListener rl=new RequestListener(port,st);
        LOG_CAT.info("starting request listener");
        rl.start();
    }

    public static void main(String[] args)
    {
        String cfgFile="cfg/q3master.cfg";
        if (0!=args.length)
            cfgFile=args[0];
        Q3Master q3Master1 = new Q3Master(cfgFile);
    }
}